Index: /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.cpp	(revision 642)
@@ -2,20 +2,17 @@
   Copyright(c) 2010 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
-
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
-
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+ .
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ .
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 #include "ccd_simulator.h"
@@ -84,5 +81,6 @@
 void ISSnoopDevice (XMLEle *root)
 {
-    INDI_UNUSED(root);
+    ISInit();
+    ccdsim->ISSnoopDevice(root);
 }
 
@@ -125,8 +123,12 @@
     TimeFactor=1;
 
+    SimulatorSettingsNV = new INumberVectorProperty;
+    TimeFactorSV = new ISwitchVectorProperty;
+
 }
 
 bool CCDSim::SetupParms()
 {
+    int nbuf;
     SetCCDParams(SimulatorSettingsN[0].value,SimulatorSettingsN[1].value,16,SimulatorSettingsN[2].value,SimulatorSettingsN[3].value);
     //  Kwiq
@@ -141,10 +143,7 @@
     seeing=SimulatorSettingsN[9].value;        //  we get real fat stars in this one
 
-
-    if(RawFrame != NULL) delete RawFrame;
-    RawFrameSize=XRes*YRes;                 //  this is pixel count
-    RawFrameSize=RawFrameSize*2;            //  Each pixel is 2 bytes
-    RawFrameSize+=512;                      //  leave a little extra at the end
-    RawFrame=new char[RawFrameSize];
+    nbuf = PrimaryCCD.getXRes() * PrimaryCCD.getYRes() * PrimaryCCD.getBPP();
+    nbuf += 512;
+    PrimaryCCD.setFrameBufferSize(nbuf);
 
     return true;
@@ -154,11 +153,12 @@
 {
 
+    int nbuf;
     SetupParms();
 
-    if(HasGuideHead) {
+    if(HasGuideHead)
+    {
         SetGuidHeadParams(500,290,8,9.8,12.6);
-        RawGuideSize=GXRes*GYRes;                 //  this is pixel count
-        RawGuideSize+=512;                      //  leave a little extra at the end
-        RawGuiderFrame=new char[RawGuideSize];
+        nbuf = GuideCCD.getXRes() * GuideCCD.getYRes();
+        GuideCCD.setFrameBufferSize(nbuf);
     }
 
@@ -174,12 +174,5 @@
 const char * CCDSim::getDefaultName()
 {
-    //fprintf(stderr,"Arrived in getDefaultName and deviceName returns '%s'\n",deviceName());
-    //if(strlen(deviceName())==0) {
         return (char *)"CCD Simulator";
-    //} else {
-    //    char n[500];
-    //    strcpy(n,deviceName());
-    //    return n;
-    //}
 }
 
@@ -190,12 +183,6 @@
     INDI::CCD::initProperties();
 
-    IUFillNumber(&EqN[0],"RA","Ra (hh:mm:ss)","%010.6m",0,24,0,0);
-    IUFillNumber(&EqN[1],"DEC","Dec (dd:mm:ss)","%010.6m",-90,90,0,0);
-    IUFillNumberVector(&EqNV,EqN,2,"","EQUATORIAL_EOD_COORD","Eq. Coordinates","Main Control",IP_RW,60,IPS_IDLE);
-    //IUFillNumberVector(&EqNV,EqN,2,deviceName(),"EQUATORIAL_EOD_COORD","Eq. Coordinates","Main Control",IP_RW,60,IPS_IDLE);
-
-    SimulatorSettingsNV = new INumberVectorProperty;
-    IUFillNumber(&SimulatorSettingsN[0],"SIM_XRES","CCD X resolution","%4.0f",0,2048,0,1280);
-    IUFillNumber(&SimulatorSettingsN[1],"SIM_YRES","CCD Y resolution","%4.0f",0,2048,0,1024);
+    IUFillNumber(&SimulatorSettingsN[0],"SIM_PrimarCCD.getXRes()","CCD X resolution","%4.0f",0,2048,0,1280);
+    IUFillNumber(&SimulatorSettingsN[1],"SIM_PrimarCCD.getYRes()","CCD Y resolution","%4.0f",0,2048,0,1024);
     IUFillNumber(&SimulatorSettingsN[2],"SIM_XSIZE","CCD X Pixel Size","%4.2f",0,60,0,5.2);
     IUFillNumber(&SimulatorSettingsN[3],"SIM_YSIZE","CCD Y Pixel Size","%4.2f",0,60,0,5.2);
@@ -209,12 +196,6 @@
     IUFillNumber(&SimulatorSettingsN[11],"SIM_SKYGLOW","Sky Glow (magnitudes)","%4.1f",0,6000,0,19.5);
     IUFillNumber(&SimulatorSettingsN[12],"SIM_OAGOFFSET","Oag Offset (arminutes)","%4.1f",0,6000,0,0);
-    IUFillNumberVector(SimulatorSettingsNV,SimulatorSettingsN,13,deviceName(),"SIMULATOR_SETTINGS","Simulator Settings","SimSettings",IP_RW,60,IPS_IDLE);
-
-
-    TelescopeTV = new ITextVectorProperty;
-    IUFillText(&TelescopeT[0],"ACTIVE_TELESCOPE","Telescope","");
-    IUFillTextVector(TelescopeTV,TelescopeT,1,deviceName(),"ACTIVE_DEVICES","Snoop Scope","Simulator Config",IP_RW,60,IPS_IDLE);
-
-    TimeFactorSV = new ISwitchVectorProperty;
+    IUFillNumberVector(SimulatorSettingsNV,SimulatorSettingsN,13,deviceName(),"SIMULATOR_SETTINGS","Simulator Settings","Simulator Config",IP_RW,60,IPS_IDLE);
+
 
     IUFillSwitch(&TimeFactorS[0],"1X","Actual Time",ISS_ON);
@@ -224,5 +205,5 @@
 
 
-    loadConfig();
+    //loadConfig();
 
     return true;
@@ -238,5 +219,4 @@
     defineNumber(SimulatorSettingsNV);
     defineSwitch(TimeFactorSV);
-    defineText(TelescopeTV);
     //IDDefText(&ConfigFileTV, NULL);
     //IDDefSwitch(&ConfigSaveRestoreSV, NULL);
@@ -257,14 +237,4 @@
 bool CCDSim::Disconnect()
 {
-    delete RawFrame;
-    RawFrameSize=0;
-    RawFrame=NULL;
-
-
-    if(RawGuiderFrame != NULL) {
-        delete RawGuiderFrame;
-        RawGuideSize=0;
-    }
-
     return true;
 }
@@ -335,4 +305,12 @@
         float timeleft;
         timeleft=CalcTimeLeft(ExpStart,ExposureRequest);
+
+        if (timeleft < 0)
+             timeleft = 0;
+
+        PrimaryCCD.setExposure(timeleft);
+        //ImageExposureN[0].value = timeleft;
+        //IDSetNumber(ImageExposureNP, NULL);
+
         if(timeleft < 1.0)
         {
@@ -347,8 +325,18 @@
         }
     }
+
     if(InGuideExposure)
     {
         float timeleft;
         timeleft=CalcTimeLeft(GuideExpStart,GuideExposureRequest);
+
+
+        if (timeleft < 0)
+             timeleft = 0;
+
+        //ImageExposureN[0].value = timeleft;
+        //IDSetNumber(ImageExposureNP, NULL);
+        GuideCCD.setExposure(timeleft);
+
         if(timeleft < 1.0)
         {
@@ -390,7 +378,8 @@
     unsigned short int val;
 
-    ptr=(unsigned short int *)RawFrame;
-
-    if(ShowStarField) {
+    ptr=(unsigned short int *) PrimaryCCD.getFrameBuffer();
+
+    if(ShowStarField)
+    {
         char gsccmd[250];
         FILE *pp;
@@ -423,5 +412,5 @@
 
         //  Start by clearing the frame buffer
-        memset(RawFrame,0,RawFrameSize);
+        memset(PrimaryCCD.getFrameBuffer(),0,PrimaryCCD.getFrameBufferSize());
 
 
@@ -439,12 +428,12 @@
         //  no offset or rotation for and y axis means
         pb=0.0;
-        pc=XRes/2/BinX;
+        pc=PrimaryCCD.getXRes()/2/PrimaryCCD.getBinX();
         pd=0.0;
-        pf=YRes/2/BinY;
+        pf=PrimaryCCD.getYRes()/2/PrimaryCCD.getBinY();
         //  and we do a simple scale for x and y locations
         //  based on the focal length and pixel size
         //  focal length in mm, pixels in microns
-        pa=focallength/PixelSizex*1000/BinX;
-        pe=focallength/PixelSizey*1000/BinY;
+        pa=focallength/PrimaryCCD.getPixelSizeX()*1000/PrimaryCCD.getBinX();
+        pe=focallength/PrimaryCCD.getPixelSizeY()*1000/PrimaryCCD.getBinY();
 
         //IDLog("Pixels are %4.2f %4.2f  pa %6.4f  pe %6.4f\n",PixelSizex,PixelSizey,pa,pe);
@@ -478,5 +467,5 @@
         float radius;
 
-        radius=sqrt((Scalex*Scalex*XRes/2.0*XRes/2.0)+(Scaley*Scaley*YRes/2.0*YRes/2.0));
+        radius=sqrt((Scalex*Scalex*PrimaryCCD.getXRes()/2.0*PrimaryCCD.getXRes()/2.0)+(Scaley*Scaley*PrimaryCCD.getYRes()/2.0*PrimaryCCD.getYRes()/2.0));
         //  we have radius in arcseconds now
         radius=radius/60;   //  convert to arcminutes
@@ -505,5 +494,5 @@
 
         //  if this is a light frame, we need a star field drawn
-        if(FrameType==FRAME_TYPE_LIGHT)
+        if(PrimaryCCD.getFrameType()==CCDChip::LIGHT_FRAME)
         {
             //sprintf(gsccmd,"gsc -c %8.6f %+8.6f -r 120 -m 0 9.1",rad+PEOffset,Dec);
@@ -593,5 +582,7 @@
         //  fwhm equivalent to the full field of view
 
-        if((FrameType==FRAME_TYPE_LIGHT)||(FrameType==FRAME_TYPE_FLAT))
+        CCDChip::CCD_FRAME ftype = PrimaryCCD.getFrameType();
+
+        if((ftype==CCDChip::LIGHT_FRAME)||(ftype==CCDChip::FLAT_FRAME))
         {
             float skyflux;
@@ -599,5 +590,5 @@
             //  calculate flux from our zero point and gain values
             glow=skyglow;
-            if(FrameType==FRAME_TYPE_FLAT)
+            if(ftype==CCDChip::FLAT_FRAME)
             {
                 //  Assume flats are done with a diffuser
@@ -610,11 +601,14 @@
             //  ok, flux represents one second now
             //  scale up linearly for exposure time
-            skyflux=skyflux*ExposureRequest*BinX*BinY;
+            skyflux=skyflux*ExposureRequest*PrimaryCCD.getBinX()*PrimaryCCD.getBinY();
             //IDLog("SkyFlux = %4.2f ExposureRequest %4.2f\n",skyflux,ExposureRequest);
 
             unsigned short *pt;
-            pt=(unsigned short int *)RawFrame;
-            for(int y=0; y<YRes/BinY; y++) {
-                for(int x=0; x<XRes/BinX; x++) {
+
+            int nwidth  = PrimaryCCD.getXRes()/PrimaryCCD.getBinX();
+            int nheight = PrimaryCCD.getYRes()/PrimaryCCD.getBinY();
+            pt=(unsigned short int *)PrimaryCCD.getFrameBuffer();
+            for(int y=0; y< nheight; y++) {
+                for(int x=0; x< nwidth; x++) {
                     float dc;   //  distance from center
                     float fp;   //  flux this pixel;
@@ -622,10 +616,10 @@
                     float vig;
 
-                    sx=XRes/2/BinX;
+                    sx=PrimaryCCD.getXRes()/2/PrimaryCCD.getBinX();
                     sx=sx-x;
-                    sy=YRes/2/BinY;
+                    sy=PrimaryCCD.getYRes()/2/PrimaryCCD.getBinY();
                     sy=sy-y;
 
-                    vig=XRes/BinX;
+                    vig=PrimaryCCD.getXRes()/PrimaryCCD.getBinX();
                     vig=vig*ImageScalex;
                     //  need to make this account for actual pixel size
@@ -654,6 +648,6 @@
 
         //  Now we add some bias and read noise
-        for(x=0; x<XRes; x++) {
-            for(y=0; y<YRes; y++) {
+        for(x=0; x<PrimaryCCD.getXRes(); x++) {
+            for(y=0; y<PrimaryCCD.getYRes(); y++) {
                 int noise;
 
@@ -671,5 +665,7 @@
         val=testvalue;
 
-        for(int x=0; x<XRes*YRes; x++)
+        int nbuf    = PrimaryCCD.getXRes()*PrimaryCCD.getYRes();
+
+        for(int x=0; x<nbuf; x++)
         {
             *ptr=val++;
@@ -686,10 +682,12 @@
     unsigned char val;
 
-    ptr=(unsigned char *)RawGuiderFrame;
+    ptr=(unsigned char *) GuideCCD.getFrameBuffer();
     testvalue++;
     if(testvalue > 255) testvalue=0;
     val=testvalue;
 
-    for(int x=0; x<GXRes*GYRes; x++) {
+    int nbuf = GuideCCD.getXRes()*GuideCCD.getYRes();
+    for(int x=0; x< nbuf; x++)
+    {
         *ptr=val++;
         ptr++;
@@ -708,5 +706,5 @@
     float flux;
 
-    if((x<0)||(x>XRes/BinX)||(y<0)||(y>YRes/BinY))
+    if((x<0)||(x>PrimaryCCD.getXRes()/PrimaryCCD.getBinX())||(y<0)||(y>PrimaryCCD.getYRes()/PrimaryCCD.getBinY()))
     {
         //  this star is not on the ccd frame anyways
@@ -750,5 +748,5 @@
             float fa;
             fa=exp(-2.0*0.7*(dc*dc)/seeing/seeing);
-            fp=fa*flux*BinX*BinY;
+            fp=fa*flux*PrimaryCCD.getBinX()*PrimaryCCD.getBinY();
             if(fp < 0) fp=0;
 
@@ -773,12 +771,12 @@
     int drew=0;
     if(x >= 0) {
-        if(x < XRes/BinX) {
+        if(x < PrimaryCCD.getXRes()/PrimaryCCD.getBinX()) {
             if(y >= 0) {
-                if(y < YRes/BinY) {
+                if(y < PrimaryCCD.getYRes()/PrimaryCCD.getBinY()) {
                     unsigned short *pt;
                     int newval;
                     drew++;
-                    pt=(unsigned short int *)RawFrame;
-                    pt+=(y*XRes/BinX);
+                    pt=(unsigned short int *)PrimaryCCD.getFrameBuffer();
+                    pt+=(y*PrimaryCCD.getXRes()/PrimaryCCD.getBinX());
                     pt+=x;
                     newval=pt[0];
@@ -793,5 +791,5 @@
 }
 
-int CCDSim::GuideNorth(float v)
+bool CCDSim::GuideNorth(float v)
 {
     float c;
@@ -801,7 +799,7 @@
     Dec=Dec+c;
 
-    return 0;
-}
-int CCDSim::GuideSouth(float v)
+    return true;
+}
+bool CCDSim::GuideSouth(float v)
 {
     float c;
@@ -811,8 +809,8 @@
     Dec=Dec-c;
 
-    return 0;
-}
-
-int CCDSim::GuideEast(float v)
+    return true;
+}
+
+bool CCDSim::GuideEast(float v)
 {
     float c;
@@ -823,7 +821,7 @@
     RA=RA-c;
 
-    return 0;
-}
-int CCDSim::GuideWest(float v)
+    return true;
+}
+bool CCDSim::GuideWest(float v)
 {
     float c;
@@ -834,24 +832,6 @@
     RA=RA+c;
 
-    return 0;
-}
-
-void CCDSim::ISSnoopDevice (XMLEle *root)
- {
-     //fprintf(stderr,"CCDSim handling snoop\n");
-     if(IUSnoopNumber(root,&EqNV)==0) {
-        float newra,newdec;
-        newra=EqN[0].value;
-        newdec=EqN[1].value;
-        if((newra != RA)||(newdec != Dec)) {
-            //fprintf(stderr,"RA %4.2f  Dec %4.2f Snooped RA %4.2f  Dec %4.2f\n",RA,Dec,newra,newdec);
-            RA=newra;
-            Dec=newdec;
-
-        }
-     } else {
-        //fprintf(stderr,"Snoop Failed\n");
-     }
- }
+    return true;
+}
 
 bool CCDSim::ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
@@ -859,5 +839,6 @@
     //  first check if it's for our device
     //IDLog("INDI::CCD::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0) {
+    if(strcmp(dev,deviceName())==0)
+    {
         //  This is for our device
         //  Now lets see if it's something we process here
@@ -899,31 +880,4 @@
     return INDI::CCD::ISNewNumber(dev,name,values,names,n);
 }
-bool CCDSim::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
-{
-    //  Ok, lets see if this is a property wer process
-    //IDLog("IndiTelescope got %d new text items name %s\n",n,name);
-    //  first check if it's for our device
-    if(strcmp(dev,deviceName())==0) {
-        //  This is for our device
-        //  Now lets see if it's something we process here
-        if(strcmp(name,TelescopeTV->name)==0) {
-            int rc;
-            //IDLog("calling update text\n");
-            TelescopeTV->s=IPS_OK;
-            rc=IUUpdateText(TelescopeTV,texts,names,n);
-            //IDLog("update text returns %d\n",rc);
-            //  Update client display
-            IDSetText(TelescopeTV,NULL);
-            saveConfig();
-            IUFillNumberVector(&EqNV,EqN,2,TelescopeT[0].text,"EQUATORIAL_EOD_COORD","Eq. Coordinates","Main Control",IP_RW,60,IPS_IDLE);
-            IDSnoopDevice(TelescopeT[0].text,"EQUATORIAL_EOD_COORD");
-            //  We processed this one, so, tell the world we did it
-            return true;
-        }
-
-    }
-
-    return INDI::DefaultDriver::ISNewText(dev,name,texts,names,n);
-}
 
 
Index: /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h	(revision 642)
@@ -2,20 +2,17 @@
   Copyright(c) 2010 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
-
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
-
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+ .
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ .
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -65,6 +62,5 @@
         bool AbortGuideFrame;
 
-        float RA;
-        float Dec;
+
         float GuideRate;
 
@@ -73,18 +69,8 @@
         time_t RunStart;
 
-        //  We are going to snoop these from a telescope
-        INumberVectorProperty EqNV;
-        INumber EqN[2];
-
         //  And this lives in our simulator settings page
 
         INumberVectorProperty *SimulatorSettingsNV;
         INumber SimulatorSettingsN[13];
-
-        ITextVectorProperty *TelescopeTV; //  A text vector that stores the telescope we want to snoop
-        IText TelescopeT[1];
-
-        //ISwitch ConfigSaveRestoreS[2];
-        //ISwitchVectorProperty ConfigSaveRestoreSV;
 
         ISwitch TimeFactorS[3];
@@ -103,6 +89,4 @@
 
         void ISGetProperties (const char *dev);
-        void ISSnoopDevice (XMLEle *root);
-
 
 
@@ -123,11 +107,10 @@
         int AddToPixel(int,int,int);
 
-        int GuideNorth(float);
-        int GuideSouth(float);
-        int GuideEast(float);
-        int GuideWest(float);
+        bool GuideNorth(float);
+        bool GuideSouth(float);
+        bool GuideEast(float);
+        bool GuideWest(float);
 
         virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
-        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
         virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
 
Index: /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp	(revision 642)
@@ -1,2 +1,20 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
+
 #include "filter_simulator.h"
 
@@ -90,9 +108,9 @@
 }
 
-int FilterSim::SelectFilter(int f)
+bool FilterSim::SelectFilter(int f)
 {
     CurrentFilter=f;
     SetTimer(500);
-    return 0;
+    return true;
 }
 
Index: /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h	(revision 642)
@@ -2,20 +2,17 @@
   Copyright(c) 2010 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -37,6 +34,10 @@
         bool Connect();
         bool Disconnect();
-        int SelectFilter(int);
+        bool SelectFilter(int);
         void TimerHit();
+
+        virtual bool SetFilterNames() { return false; }
+        virtual bool GetFilterNames(const char *deviceName, const char* groupName) { return false; }
+
 
 };
Index: /BAORadio/libindi/libindi/drivers/focuser/tcfs.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/focuser/tcfs.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/focuser/tcfs.cpp	(revision 642)
@@ -82,5 +82,5 @@
 	if(dev && strcmp (mydev, dev)) return;
 	ISInit();
-        tcfs->ISNewSwitch(name, states, names, num);
+        tcfs->ISNewSwitch(dev, name, states, names, num);
 }
 
@@ -89,5 +89,5 @@
 	if(dev && strcmp (mydev, dev)) return;
 	ISInit();
-        tcfs->ISNewText(name, texts, names, num);
+        tcfs->ISNewText(dev, name, texts, names, num);
 }
 
@@ -96,5 +96,5 @@
 	if(dev && strcmp (mydev, dev)) return;
 	ISInit();
-        tcfs->ISNewNumber(name, values, names, num);
+        tcfs->ISNewNumber(dev, name, values, names, num);
 }
 
@@ -239,6 +239,5 @@
     if (tty_connect(tProp->tp[0].text, 19200, 8, 0, 1, &fd) != TTY_OK)
     {
-        ConnectSP->s = IPS_ALERT;
-        IDSetSwitch (ConnectSP, "Error connecting to port %s. Make sure you have BOTH read and write permission to the port.", tProp->tp[0].text);
+        IDMessage(deviceName(), "Error connecting to port %s. Make sure you have BOTH read and write permission to the port.", tProp->tp[0].text);
 	return false;
     }
@@ -252,5 +251,5 @@
             if (!strcmp(response, "!"))
             {
-                setConnected(true, IPS_OK, "Successfully connected to TCF-S Focuser in Manual Mode.");
+                IDMessage(deviceName(), "Successfully connected to TCF-S Focuser in Manual Mode.");
 
                 IUResetSwitch(FocusModeSP);
@@ -275,5 +274,5 @@
     }
 
-    setConnected(false, IPS_ALERT, "Error connecting to TCF-S focuser...");
+    IDMessage(deviceName(), "Error connecting to TCF-S focuser...");
     return false;
 
@@ -306,5 +305,5 @@
 **
 *****************************************************************/
-bool TCFS::ISNewNumber (const char *name, double values[], char *names[], int n)
+bool TCFS::ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
 {
 
@@ -317,5 +316,5 @@
   {
       resetProperties();
-      IDMessage(deviceID, "TCF-S is offline. Connect before issiung any commands.");
+      IDMessage(deviceName(), "TCF-S is offline. Connect before issiung any commands.");
       return false;
   }
@@ -355,4 +354,6 @@
       return true;
   }
+
+  return DefaultDriver::ISNewNumber (dev, name, values, names, n);
     
 }
@@ -362,5 +363,5 @@
 **
 *****************************************************************/
-bool TCFS::ISNewText (const char *name, char *texts[], char *names[], int n)
+bool TCFS::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
 {
     ITextVectorProperty * tProp = getText(name);
@@ -382,5 +383,5 @@
 
 
-    return false;
+    return DefaultDriver::ISNewText(dev, name, texts, names, n);
 	
 }
@@ -390,10 +391,10 @@
 **
 *****************************************************************/
-bool TCFS::ISNewSwitch (const char *name, ISState *states, char *names[], int n)
+bool TCFS::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
 {
 
     ISwitch *current_active_switch = NULL, *target_active_switch = NULL;
     // First process parent!
-    if (INDI::DefaultDriver::ISNewSwitch(deviceID, name, states, names, n) == true)
+    if (INDI::DefaultDriver::ISNewSwitch(deviceName(), name, states, names, n) == true)
         return true;
 
@@ -416,5 +417,5 @@
     {
       resetProperties();
-      IDMessage(deviceID, "TCF-S is offline. Connect before issiung any commands.");
+      IDMessage(deviceName(), "TCF-S is offline. Connect before issiung any commands.");
       return false;
     }
@@ -663,5 +664,5 @@
 
 
-    return false;
+    return DefaultDriver::ISNewSwitch(dev, name, states, names, n);
 }
 
@@ -930,4 +931,4 @@
 const char * TCFS::getDefaultName()
 {
-    return "TCFS";
-}
+    return mydev;
+}
Index: /BAORadio/libindi/libindi/drivers/focuser/tcfs.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/focuser/tcfs.h	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/focuser/tcfs.h	(revision 642)
@@ -66,7 +66,7 @@
     // Standard INDI interface fucntions
     virtual void ISGetProperties(const char *dev);
-    virtual bool ISNewNumber (const char *name, double values[], char *names[], int n);
-    virtual bool ISNewText (const char *name, char *texts[], char *names[], int n);
-    virtual bool ISNewSwitch (const char *name, ISState *states, char *names[], int n);
+    virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+    virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+    virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
  	
 
